(* JVESA test program. *)

(* Notice: This is only a _TEST_ program so don't expect anything
           fancy or nice effects. The view on screen looks very
           boring and is generally very dull indeed. And it may
           even have bugs..
*)

program JVESATST;

(* Some VESA modes:
     101h - 640x480x256
     103h - 800x600x256
     105h - 1024x768x256
     107h - 1280x1024x256
*)
{$g+}

uses crt,jvesa;

const hxchr:array[0..15]of char=(
  '0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f');
function wd2hx(src:word):string;
begin
 wd2hx:=hxchr[(src shr 12)and 15]+hxchr[(src shr 8)and 15]+
  hxchr[(src shr 4)and 15]+hxchr[src and 15];
end;

const sprlev=64;
      sprkor=64;
      sprsize=sprlev*sprkor;

var a,b,d,e,f,l,x,y:word; c:shortint;
    scr,spr:pointer; scrseg,sprseg:word;

procedure checkvesa;
begin
 jvgetsvgainfo;
 with vgainfo do
  if (vesasig[0]<>ord('V')) and
     (vesasig[1]<>ord('E')) and
     (vesasig[2]<>ord('S')) and
     (vesasig[3]<>ord('A')) then begin
   writeln('NO VESA SUPPORT FOUND! (REQUIRED)');
   write('CONTINUE (y/N) ? ');
   if upcase(readkey)<>'Y' then halt;
  end;
 if not jvinitsvga($101) then begin
   writeln('NO 640*480*256 SUPPORT FOUND! (REQUIRED)');
   write('CONTINUE (y/N) ? ');
   if upcase(readkey)<>'Y' then halt;
  end;
 if vgainfo.vesaver<258 then begin
   writeln('VESA VERSION LESS THAN 1.2!');
   write('CONTINUE (y/N) ? ');
   if upcase(readkey)<>'Y' then halt;
  end;
end;

procedure vesainfo;
begin
 clrscr;
 write(' **  JVESA  **  Copyright 1996 by Jetro Lauha  ** ');
 writeln('version '+jvesaversmajstr+'.'+jvesaversminstr);
 writeln;
 write('         Signature : ');
 with vgainfo do for a:=0 to 3 do write(chr(vesasig[a]));
 writeln;
 writeln('           Version : ',hi(vgainfo.vesaver),'.',lo(vgainfo.vesaver));
 writeln('      Total memory : ',vgainfo.totalmem*64);
 writeln('       Window size : ',modeinfo.winsize,'k (',wsize,' bytes)');
 writeln('Window granularity : ',modeinfo.wingran,'k (',wgran,' bytes)');
 writeln;
 write('Window A supported : ');
 if winasup then begin write('YES (');
  if not winaread then write('NO '); write('READ/');
  if not winawrite then write('NO '); write('WRITE)  ');
  writeln('Segment: 0',wd2hx(modeinfo.winaseg),'h');
 end else writeln('NO');
 write('Window B supported : ');
 if winbsup then begin write('YES (');
  if not winbread then write('NO '); write('READ/');
  if not winbwrite then write('NO '); write('WRITE)  ');
  writeln('Segment: 0',wd2hx(modeinfo.winbseg),'h');
 end else writeln('NO');
 writeln;
 writeln('Write segment : 0',wd2hx(vesaseg),'h  Read segment : 0',wd2hx(vesarseg),'h');
 writeln;
 write('                                        Press a key to continue...');
 readkey;
end;

(* Yes, this source is a bit ugly and there is not enough comments. *)
(*      Have fun.                                                   *)

procedure vesatest;
begin
 getmem(scr,64016); scrseg:=seg(scr^)+1;
 getmem(spr,sprsize+16); sprseg:=seg(spr^)+1;

 jvsetsvgamode($101);

 jloadpcx(scrseg,'jvesats2.pcx');
 for b:=1 to sprkor do
  move(mem[scrseg:b*320+1],mem[sprseg:(b-1)*sprlev],sprlev);

 jloadpcxpal('jvesats1.pcx');
 jvloadsvgapcx('jvesats1.pcx',0,540);

 jvfillbox(20,100,619,390,1);
 for a:=0 to 579 do jvscanline(a div 8+70,a div 4+70,a,63-a div 17);

 jvfillbox(70,330,170,339,4);
 jvfillbox(71,341,171,350,4);
 jvfillbox(72,352,172,361,4);
 jvfillbox(73,363,173,372,4);
 jvfillbox(74,374,174,383,4);
 jvblock(sprseg,0,500,110,sprlev,sprkor);
 jvblock(sprseg,0,501,180,sprlev,sprkor);
 jvblock(sprseg,0,502,250,sprlev,sprkor);
 jvblock(sprseg,0,503,320,sprlev,sprkor);
 jvsprite(sprseg,0,300,110,sprlev,sprkor);
 jvsprite(sprseg,0,301,180,sprlev,sprkor);
 jvsprite(sprseg,0,302,250,sprlev,sprkor);
 jvsprite(sprseg,0,303,320,sprlev,sprkor);

 jvgetblock(scrseg,0,424,419,64,70);
 jvblock(scrseg,0,400,110,64,70);
 jvblock(scrseg,0,401,180,64,70);
 jvblock(scrseg,0,402,250,64,70);
 jvblock(scrseg,0,403,320,64,70);
 jvsprite(scrseg,0,200,110,64,70);
 jvsprite(scrseg,0,201,180,64,70);
 jvsprite(scrseg,0,202,250,64,70);
 jvsprite(scrseg,0,203,320,64,70);

 jvgetblock(scrseg,0,500,110,32,32);

 a:=0; c:=1; l:=0;
 repeat
  inc(l);
  x:=110+a; y:=220+a;
  a:=a+c;
  if (a=40) or (a=0) then c:=-c;
  jvgetblock(scrseg,0,x,y,sprlev,sprkor);
  jvsprite(sprseg,0,x,y,sprlev,sprkor);
  jvrc;
  jvsetdisplay(0,a);
  jvblock(scrseg,0,x,y,sprlev,sprkor);
 until keypressed;

 while keypressed do readkey;

 asm mov ax,03h; int 10h; end;

 freemem(spr,sprsize+16);
 freemem(scr,64016);
end;

begin
 checkvesa;
 vesainfo;
 vesatest;
end.